using PrtOn.Properties;
using System.Globalization;
using System.Reflection;
using static System.Runtime.InteropServices.JavaScript.JSType;

namespace PrtOn
{
    /// <summary>
    /// tH[NX
    /// </summary>
    public partial class Form1 : Form
    {
        /// <summary>
        /// ^Cg
        /// </summary>
        private readonly string title = "MODE 7 LIST EXE";

        /// <summary>
        /// o̓t@C̊gq
        /// </summary>
        private readonly string outputExt = ".png";

        /// <summary>
        /// ftHgRXgN^[
        /// </summary>
        public Form1()
        {
            InitializeComponent();
        }

        /// <summary>
        /// tH[[h
        /// </summary>
        /// <param name="sender">Cxg𔭐IuWFNg</param>
        /// <param name="e">Cxgf[^</param>
        private void Form1_Load(object sender, EventArgs e)
        {
            // ^Cgo[̕ݒ
            Version? version = Assembly.GetExecutingAssembly().GetName().Version;
            Text = title + $" Ver.{version}";

            // OS̃J`擾Đݒ
            SetCulture(CultureInfo.CurrentUICulture.Name);

            // bZ[W\[X擾ĕ\
            label1.Text = Properties.Resources.top_message;

            // o̓t@C͏Ă
            label2.Text = "";

            // ݒl
            labelLineNo.Text = Properties.Resources.lineno_width;
            textLineNo.Text = Settings.Default.LineNoColumn.ToString();
            labelColMax.Text = Properties.Resources.line_width;
            textColMax.Text = Settings.Default.ColumnMax.ToString();
            labelScaleW.Text = Properties.Resources.scale_width;
            textScaleW.Text = Settings.Default.ScaleWidth.ToString();
            labelScaleH.Text = Properties.Resources.scale_height;
            textScaleH.Text = Settings.Default.ScaleHeight.ToString();

            checkBoxFont.Text = Properties.Resources.font_select;
            labelLeading.Text = Properties.Resources.leading_dot;
            textLeading.Text = Settings.Default.LeadingDot.ToString();
            labelMargin.Text = Properties.Resources.margin;
            textMargin.Text = Settings.Default.Margin.ToString();

            // \ʒu
            textLineNo.Location = new Point(labelLineNo.Location.X + labelLineNo.Size.Width, textLineNo.Location.Y);
            labelColMax.Location = new Point(textLineNo.Location.X + textLineNo.Size.Width + 4, labelColMax.Location.Y);
            textColMax.Location = new Point(labelColMax.Location.X + labelColMax.Size.Width, textColMax.Location.Y);
            labelScaleW.Location = new Point(textColMax.Location.X + textColMax.Size.Width + 4, labelScaleW.Location.Y);
            textScaleW.Location = new Point(labelScaleW.Location.X + labelScaleW.Size.Width, textScaleW.Location.Y);
            labelScaleH.Location = new Point(textScaleW.Location.X + textScaleW.Size.Width + 4, labelScaleH.Location.Y);
            textScaleH.Location = new Point(labelScaleH.Location.X + labelScaleH.Size.Width, textScaleH.Location.Y);

            checkBoxFont.Text = Properties.Resources.font_select;
            labelLeading.Location = new Point(checkBoxFont.Location.X + checkBoxFont.Size.Width + 4, labelLeading.Location.Y);
            textLeading.Location = new Point(labelLeading.Location.X + labelLeading.Size.Width, textLeading.Location.Y);
            labelMargin.Location = new Point(textLeading.Location.X + textLeading.Size.Width + 4, labelMargin.Location.Y);
            textMargin.Location = new Point(labelMargin.Location.X + labelMargin.Size.Width, textMargin.Location.Y);

            // 摜\
            pictureBox1.SizeMode = PictureBoxSizeMode.AutoSize;
        }

        /// <summary>
        /// hbOCxgnh
        /// </summary>
        /// <param name="sender">Cxg𔭐IuWFNg</param>
        /// <param name="e">Cxgf[^</param>
        private void Form1_DragEnter_1(object sender, DragEventArgs e)
        {
            if (e.Data == null)
            {
                return;
            }

            if (e.Data.GetDataPresent(DataFormats.FileDrop))
            {
                e.Effect = DragDropEffects.Copy;
            }
            else
            {
                e.Effect = DragDropEffects.None;
            }
        }

        /// <summary>
        /// hbvCxgnh
        /// </summary>
        /// <param name="sender">Cxg𔭐IuWFNg</param>
        /// <param name="e">Cxgf[^</param>
        private void Form1_DragDrop_1(object sender, DragEventArgs e)
        {
            if (e.Data == null)
            {
                return;
            }

            if (e.Data.GetDataPresent(DataFormats.FileDrop))
            {
                var data = e.Data.GetData(DataFormats.FileDrop);
                if (data is string[] files)
                {
                    foreach (string file in files)
                    {
                        string savePath = $"{file}{outputExt}";
                        label1.Text = $"{Properties.Resources.input_file}: {file}";
                        label2.Text = $"{Properties.Resources.output_file}: {savePath}";

                        (int[] program, int lineMax) = ProcessFile(file);
                        if (lineMax != 0)
                        {
                            ProcessPrintOut(program, lineMax, savePath);
                        }
                    }
                }
            }
        }

        /// <summary>
        /// J`̃Zbg
        /// </summary>
        /// <param name="cultureName">J``</param>
        private void SetCulture(string cultureName)
        {
            CultureInfo culture = new(cultureName);
            Thread.CurrentThread.CurrentUICulture = culture;
            Thread.CurrentThread.CurrentCulture = culture;
        }

        /// <summary>
        // t@C郁\bh
        /// </summary>
        /// <param name="filePath">hbOꂽt@C̃pX</param>
        private (int[] program, int lineMax) ProcessFile(string filePath)
        {
            PBList bplist = new PBList();
            List<int> program = new List<int>();
            int lineCount = 0;

            try
            {
                string[] lines = File.ReadAllLines(filePath);       // Xgt@Cǂݍ

                foreach (string line in lines)
                {
                    int colmnCount = 0;

                    string pbline = bplist.ConvertString(line);         // ꕶGXP[vɕϊ
                    textBox1.AppendText(pbline + Environment.NewLine);  // t@C̓eeLXg{bNXɕ\

                    string rest = pbline;
                    while (rest.Length > 0)
                    {
                        (int code, int length) = bplist.ChangePBCode(rest); // PB̕R[hւ̕ϊ
                        //textBox1.AppendText(code.ToString("X2"));   // R[heLXg{bNXɕ\
                        program.Add(code);
                        rest = rest.Substring(length);
                        colmnCount++;
                        if (colmnCount >= Settings.Default.ColumnMax)
                        {
                            if (rest.Length > 0)
                            {
                                program.Add(-2);        // rs
                                colmnCount = Settings.Default.LineNoColumn + 1;
                                lineCount++;
                                //textBox1.AppendText(Environment.NewLine + " ".PadLeft(Settings.Default.LineNoColumn));
                            }
                        }
                    }
                    //textBox1.AppendText(Environment.NewLine);
                    program.Add(-1);                // s
                    lineCount++;
                }
            }
            catch (Exception e)
            {
                textBox1.AppendText($"{Properties.Resources.error_hedder}1: {e.Message}{Environment.NewLine}"); // G[̓eeLXg{bNXɕ\
            }

            return (program.ToArray(), lineCount);
        }

        /// <summary>
        /// 摜쐬
        /// </summary>
        /// <param name="program">o͑Ώۃf[^</param>
        private void ProcessPrintOut(int[] program, int lineMax, string savePath)
        {
            try
            {
                // \[X摜擾
                Bitmap bmp;
                if (checkBoxFont.Checked)
                {
                    bmp = Properties.Resources.font100;
                }
                else
                {
                    bmp = Properties.Resources.fontfull;
                }
                int gridWidth = 8;
                int gridHeight = 16;
                int cellWidth = bmp.Width / gridWidth;
                int cellHeight = bmp.Height / gridHeight;
                int fontWidth = (int)(cellWidth * Settings.Default.ScaleWidth / 100);
                int fontHeight = (int)(cellHeight * Settings.Default.ScaleHeight / 100);
                int leadingHeight = (int)(fontHeight + fontHeight * Settings.Default.LeadingDot / 100);
                int margineLeft = (int)(fontWidth * Settings.Default.Margin / 100);
                int margineRight = (int)(fontWidth * Settings.Default.Margin / 100);
                int margineTop = (int)(fontHeight * Settings.Default.Margin / 100);
                int margineBottom = (int)(fontHeight * Settings.Default.Margin / 100);

                int paperWidth = Settings.Default.ColumnMax * fontWidth + margineLeft + margineRight;
                int paperHeight = lineMax * leadingHeight + margineTop + margineBottom;
                //textBox1.AppendText($"{paperWidth} {paperHeight}{Environment.NewLine}");

                Bitmap destBmp = new Bitmap(paperWidth, paperHeight);
                using (Graphics g = Graphics.FromImage(destBmp))
                {
                    g.InterpolationMode = System.Drawing.Drawing2D.InterpolationMode.HighQualityBicubic;  // iȏk
                    g.FillRectangle(Brushes.White, new Rectangle(0, 0, paperWidth, paperHeight));

                    int lineCount = 0;
                    int colmnCount = 0;

                    foreach (int code in program)
                    {
                        if (code < 0)
                        {
                            lineCount++;

                            if (code == -1)
                            {
                                // s
                                colmnCount = 0;
                            }
                            else
                            {
                                // rs
                                colmnCount = Settings.Default.LineNoColumn + 1;
                            }
                            continue;
                        }

                        int x = (code >> 4) & 0x0F;
                        int y = code & 0x0F;
                        Rectangle srcRect = new Rectangle(x * cellWidth, y * cellHeight, cellWidth, cellHeight);
                        Rectangle destRect = new Rectangle(colmnCount * fontWidth + margineLeft, lineCount * leadingHeight + margineTop, fontWidth, fontHeight);
                        g.DrawImage(bmp, destRect, srcRect, GraphicsUnit.Pixel);

                        colmnCount++;
                    }
                }

                // PictureBoxɕ\
                pictureBox1.Image = destBmp;

                // PictureBox̓ePNGt@CƂĕۑ
                destBmp.Save(savePath, System.Drawing.Imaging.ImageFormat.Png);
                textBox1.AppendText($"{Resources.end_message}: {savePath}{Environment.NewLine}");
            }
            catch (Exception e)
            {
                textBox1.AppendText($"{Properties.Resources.error_hedder}2: {e.Message}{Environment.NewLine}"); // G[̓eeLXg{bNXɕ\
            }
        }

        /// <summary>
        /// sԍ̌̒l
        /// </summary>
        /// <param name="sender">Cxg𔭐IuWFNg</param>
        /// <param name="e">LZ\Cxgf[^</param>
        private void textLineNo_Validating(object sender, System.ComponentModel.CancelEventArgs e)
        {
            int no;
            int min = Settings.Default.LineNoColmnMin;
            int max = Settings.Default.LineNoColmnMax;

            if (int.TryParse(textLineNo.Text, out no))
            {
                if ((no >= min) && (no <= max))
                {
                    Settings.Default.LineNoColumn = no;
                    Settings.Default.Save();
                    return;
                }
            }

            string item = labelLineNo.Text;
            string tilde = Properties.Resources.char_tilde;
            textBox1.AppendText($"{item} : {Properties.Resources.range_message} {min}{tilde}{max}{Environment.NewLine}");
            textLineNo.Text = Settings.Default.LineNoColumn.ToString();
        }

        /// <summary>
        /// Ps̒̕l
        /// </summary>
        /// <param name="sender">Cxg𔭐IuWFNg</param>
        /// <param name="e">LZ\Cxgf[^</param>
        private void textColMax_Validating(object sender, System.ComponentModel.CancelEventArgs e)
        {
            int no;
            int min = Settings.Default.ColumnCountMin;
            int max = Settings.Default.ColumnCountMax;

            if (int.TryParse(textColMax.Text, out no))
            {
                if ((no >= min) && (no <= max))
                {
                    Settings.Default.ColumnMax = no;
                    Settings.Default.Save();
                    return;
                }
            }

            string item = labelColMax.Text;
            string tilde = Properties.Resources.char_tilde;
            textBox1.AppendText($"{item} : {Properties.Resources.range_message} {min}{tilde}{max}{Environment.NewLine}");
            textColMax.Text = Settings.Default.ColumnMax.ToString();
        }

        /// <summary>
        /// kځij̒l
        /// </summary>
        /// <param name="sender">Cxg𔭐IuWFNg</param>
        /// <param name="e">LZ\Cxgf[^</param>
        private void textScaleW_Validating(object sender, System.ComponentModel.CancelEventArgs e)
        {
            int no;
            int min = Settings.Default.ScaleMin;
            int max = Settings.Default.ScaleMax;

            if (int.TryParse(textScaleW.Text, out no))
            {
                if ((no >= min) && (no <= max))
                {
                    Settings.Default.ScaleWidth = no;
                    Settings.Default.Save();
                    return;
                }
            }

            string item = labelScaleH.Text;
            string tilde = Properties.Resources.char_tilde;
            textBox1.AppendText($"{item} : {Properties.Resources.range_message} {min}{tilde}{max}{Environment.NewLine}");
            textScaleW.Text = Settings.Default.ScaleWidth.ToString();
        }

        /// <summary>
        /// kځicj̒l
        /// </summary>
        /// <param name="sender">Cxg𔭐IuWFNg</param>
        /// <param name="e">LZ\Cxgf[^</param>
        private void textScaleH_Validating(object sender, System.ComponentModel.CancelEventArgs e)
        {
            int no;
            int min = Settings.Default.ScaleMin;
            int max = Settings.Default.ScaleMax;

            if (int.TryParse(textScaleW.Text, out no))
            {
                if ((no >= min) && (no <= max))
                {
                    Settings.Default.ScaleHeight = no;
                    Settings.Default.Save();
                    return;
                }
            }

            string item = labelScaleH.Text;
            string tilde = Properties.Resources.char_tilde;
            textBox1.AppendText($"{item} : {Properties.Resources.range_message} {min}{tilde}{max}{Environment.NewLine}");
            textScaleH.Text = Settings.Default.ScaleHeight.ToString();
        }

        /// <summary>
        /// s̒l
        /// </summary>
        /// <param name="sender">Cxg𔭐IuWFNg</param>
        /// <param name="e">LZ\Cxgf[^</param>
        private void textLeading_Validating(object sender, System.ComponentModel.CancelEventArgs e)
        {
            int no;
            int min = Settings.Default.LeadingMin;
            int max = Settings.Default.LeadingMax;

            if (int.TryParse(textLeading.Text, out no))
            {
                if ((no >= min) && (no <= max))
                {
                    Settings.Default.LeadingDot = no;
                    Settings.Default.Save();
                    return;
                }
            }

            string item = labelLeading.Text;
            string tilde = Properties.Resources.char_tilde;
            textBox1.AppendText($"{item} : {Properties.Resources.range_message} {min}{tilde}{max}{Environment.NewLine}");
            textLeading.Text = Settings.Default.LeadingDot.ToString();
        }

        /// <summary>
        /// ]̒l
        /// </summary>
        /// <param name="sender">Cxg𔭐IuWFNg</param>
        /// <param name="e">LZ\Cxgf[^</param>
        private void textMargin_Validating(object sender, System.ComponentModel.CancelEventArgs e)
        {
            int no;
            int min = Settings.Default.MarginMin;
            int max = Settings.Default.MarginMax;

            if (int.TryParse(textMargin.Text, out no))
            {
                if ((no >= min) && (no <= max))
                {
                    Settings.Default.Margin = no;
                    Settings.Default.Save();
                    return;
                }
            }

            string item = labelMargin.Text;
            string tilde = Properties.Resources.char_tilde;
            textBox1.AppendText($"{item} : {Properties.Resources.range_message} {min}{tilde}{max}{Environment.NewLine}");
            textMargin.Text = Settings.Default.Margin.ToString();
        }

        /// <summary>
        /// PB-100tHgE`FbN{bNX
        /// </summary>
        /// <param name="sender">Cxg𔭐IuWFNg</param>
        /// <param name="e">LZ\Cxgf[^</param>
        private void checkBoxFont_CheckStateChanged(object sender, EventArgs e)
        {
            Settings.Default.FontSelect = checkBoxFont.Checked;
            Settings.Default.Save();
        }
    }
}
